workflow:
  rules:
    # Do not run CI when commit title have
    # WIP, NO-CI or 🚧 (gitmoji for "work in progress", aka :construction:)
    - if: |
        $CI_COMMIT_TITLE =~ /.*WIP.*/ ||
        $CI_COMMIT_TITLE =~ /.*NO-CI.*/ ||
        $CI_COMMIT_TITLE =~ /.*🚧.*/
      when: never
    # Disable pipeline on non-main branches
    #- if: $CI_COMMIT_BRANCH !~ /.*master.*/ && $CI_COMMIT_BRANCH !~ /.*dev.*/
    #  when: never
    # Run the CI otherwise (depending on `only/except` key per jobs)
    - when: always


# Spécifiez la version de la syntaxe de GitLab CI/CD
# que nous utilisons
stages:
  #- code_quality 
  #- code_efficacity
  - build
  - deploy


before_script:
  - |
    # docker variables for name and tag of new image
    export DOCKER_TAG="${CI_COMMIT_SHA:0:8}"
    export DOCKER_REPO="$CI_REGISTRY_IMAGE"
    export DOCKER_IMAGE="${DOCKER_REPO}:${DOCKER_TAG}"
    export DOCKER_CACHE_IMAGE="${DOCKER_REPO}:${CI_COMMIT_REF_NAME}"
    export DOCKER_LATEST="${DOCKER_REPO}:latest"


.ssh_init:
  before_script:
    - eval `ssh-agent -s` # start ssh-agent
    - echo "${SSH_PRIVATE_KEY}" | ssh-add - # add ssh key to agent
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - touch ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts


  ##- apt-get update -qq
  ##- apt-get install -qq git
  # Setup SSH deploy keys
  ##- 'which ssh-agent || ( apt-get install -qq openssh-client )'
  ##- eval $(ssh-agent -s)
  ##- ssh-add <(echo "$SSH_PRIVATE_KEY")
  ##- mkdir -p ~/.ssh
  ##- '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'

# Définit les jobs pour chaque étape
build-prod:
  # Lightweight image with support of running docker in docker
  image: docker:20.10.23
  services:
    - docker:dind
  stage: build
  when: always
  only:
    - main
  script:
    - cp ${PROD_ENV} .env
    - cp ${FIREBASE} ./config/firebase.json
    # Login to Container registry
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
    # Load existing images for build optimisation
    - docker pull "$DOCKER_CACHE_IMAGE" || true # allow failure
    - docker pull "$DOCKER_IMAGE" || true # allow failure
    - docker build --pull --cache-from "$DOCKER_IMAGE" --cache-from "$DOCKER_CACHE_IMAGE" -t "$DOCKER_IMAGE" -t "$DOCKER_CACHE_IMAGE" -t "$DOCKER_LATEST" .
    # Save built image to Container registry under branch name tag and commit hash tag
    - docker push --all-tags "$DOCKER_REPO"

deploy-prod:
  stage: deploy
  only:
    - main
  extends: .ssh_init
  when: manual
  script:
    # Login to Gitlab Container registry
    - ssh -oStrictHostKeyChecking=no "${SSH_USER}@${SSH_HOST}" "docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY"
    # Download and run new image + dummy end command to end ssh properly
    - ssh -oStrictHostKeyChecking=no "${SSH_USER}@${SSH_HOST}"  '
      cd /tools/dreambook/prod/notif;
      docker-compose pull;
      docker-compose up -d;
      uname -a ;'


build-dev:
  # Lightweight image with support of running docker in docker
  image: docker:20.10.23
  services:
    - docker:dind
  stage: build
  when: always
  only:
    - dev
  script:
    - cp ${DEV_ENV} .env
    - cp ${FIREBASE} ./config/firebase.json
    # Login to Container registry
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
    # Load existing images for build optimisation
    - docker pull "$DOCKER_CACHE_IMAGE" || true # allow failure
    - docker pull "$DOCKER_IMAGE" || true # allow failure
    - docker build --pull --cache-from "$DOCKER_IMAGE" --cache-from "$DOCKER_CACHE_IMAGE" -t "$DOCKER_IMAGE" -t "$DOCKER_CACHE_IMAGE" -t "$DOCKER_LATEST" .
    # Save built image to Container registry under branch name tag and commit hash tag
    - docker push --all-tags "$DOCKER_REPO"

deploy-dev:
  stage: deploy
  only:
    - dev
  extends: .ssh_init
  when: always
  script:
    # Login to Gitlab Container registry
    - ssh -oStrictHostKeyChecking=no "${SSH_USER}@${SSH_HOST}" "docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY"
    # Download and run new image + dummy end command to end ssh properly
    - ssh -oStrictHostKeyChecking=no "${SSH_USER}@${SSH_HOST}"  '
      cd /tools/dreambook/dev/notif;
      docker-compose pull;
      docker-compose up -d;
      uname -a ;'
